org.bouncycastle.crypto.digests

## Class Kangaroo.MarsupilamiFourteen

- java.lang.Object
- - org.bouncycastle.crypto.digests.Kangaroo.MarsupilamiFourteen

- All Implemented Interfaces:
    Digest, ExtendedDigest, Xof
  Enclosing class:
    Kangaroo

      public static class Kangaroo.MarsupilamiFourteen
      extends java.lang.Object

  MarsupilamiFourteen.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `MarsupilamiFourteen()` Constructor.
    `MarsupilamiFourteen(CryptoServicePurpose purpose)`
    `MarsupilamiFourteen(int pLength, CryptoServicePurpose purpose)` Constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `doFinal(byte[] pOut, int pOutOffset)` close the digest, producing the final digest value.
    `int` | `doFinal(byte[] pOut, int pOutOffset, int pOutLen)` Output the results of the final calculation for this digest to outLen number of bytes.
    `int` | `doOutput(byte[] pOut, int pOutOffset, int pOutLen)` Start outputting the results of the final calculation for this digest.
    `java.lang.String` | `getAlgorithmName()` return the algorithm name
    `int` | `getByteLength()` Return the size in bytes of the internal buffer the digest applies it's compression function to.
    `int` | `getDigestSize()` return the size, in bytes, of the digest produced by this message digest.
    `void` | `init(Kangaroo.KangarooParameters pParams)` Initialise the digest.
    `void` | `reset()` reset the digest back to it's initial state.
    `void` | `update(byte pIn)` update the message digest with a single byte.
    `void` | `update(byte[] pIn, int pInOff, int pLen)` update the message digest with a block of bytes.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### MarsupilamiFourteen

          public MarsupilamiFourteen()

      Constructor.

    - #### MarsupilamiFourteen

          public MarsupilamiFourteen(int pLength,
                                     CryptoServicePurpose purpose)

      Constructor.
      Parameters:
        `pLength` - the digest length

    - #### MarsupilamiFourteen

          public MarsupilamiFourteen(CryptoServicePurpose purpose)

  - ### Method Detail

    - #### getAlgorithmName

          public java.lang.String getAlgorithmName()

      Description copied from interface: `Digest`
      return the algorithm name
      Returns:
        the algorithm name

    - #### getByteLength

          public int getByteLength()

      Description copied from interface: `ExtendedDigest`
      Return the size in bytes of the internal buffer the digest applies it's compression function to.
      Specified by:
        `getByteLength` in interface `ExtendedDigest`
      Returns:
        byte length of the digests internal buffer.

    - #### getDigestSize

          public int getDigestSize()

      Description copied from interface: `Digest`
      return the size, in bytes, of the digest produced by this message digest.
      Specified by:
        `getDigestSize` in interface `Digest`
      Returns:
        the size, in bytes, of the digest produced by this message digest.

    - #### init

          public void init(Kangaroo.KangarooParameters pParams)

      Initialise the digest.
      Parameters:
        `pParams` - the parameters

    - #### update

          public void update(byte pIn)

      Description copied from interface: `Digest`
      update the message digest with a single byte.
      Specified by:
        `update` in interface `Digest`
      Parameters:
        `pIn` - the input byte to be entered.

    - #### update

          public void update(byte[] pIn,
                             int pInOff,
                             int pLen)

      Description copied from interface: `Digest`
      update the message digest with a block of bytes.
      Specified by:
        `update` in interface `Digest`
      Parameters:
        `pIn` - the byte array containing the data.
        `pInOff` - the offset into the byte array where the data starts.
        `pLen` - the length of the data.

    - #### doFinal

          public int doFinal(byte[] pOut,
                             int pOutOffset)

      Description copied from interface: `Digest`
      close the digest, producing the final digest value. The doFinal call leaves the digest reset.
      Specified by:
        `doFinal` in interface `Digest`
      Parameters:
        `pOut` - the array the digest is to be copied into.
        `pOutOffset` - the offset into the out array the digest is to start at.

    - #### doFinal

          public int doFinal(byte[] pOut,
                             int pOutOffset,
                             int pOutLen)

      Description copied from interface: `Xof`
      Output the results of the final calculation for this digest to outLen number of bytes.
      Specified by:
        `doFinal` in interface `Xof`
      Parameters:
        `pOut` - output array to write the output bytes to.
        `pOutOffset` - offset to start writing the bytes at.
        `pOutLen` - the number of output bytes requested.
      Returns:
        the number of bytes written

    - #### doOutput

          public int doOutput(byte[] pOut,
                              int pOutOffset,
                              int pOutLen)

      Description copied from interface: `Xof`
      Start outputting the results of the final calculation for this digest. Unlike doFinal, this method will continue producing output until the Xof is explicitly reset, or signals otherwise.
      Specified by:
        `doOutput` in interface `Xof`
      Parameters:
        `pOut` - output array to write the output bytes to.
        `pOutOffset` - offset to start writing the bytes at.
        `pOutLen` - the number of output bytes requested.
      Returns:
        the number of bytes written

    - #### reset

          public void reset()

      Description copied from interface: `Digest`
      reset the digest back to it's initial state.
      Specified by:
        `reset` in interface `Digest`